#! /bin/sh -e

# /* Linux i386 - gcc 2.7.2.1 (ELF shared library)
#  * a very simple make driver
#  * Copyright (C) 1996, 1997 Markus F.X.J. Oberhumer
#  */

cat config.h >/dev/null || exit 1

x=`grep -h "^VERSION=" configure`
test -n "$x" || exit 1
eval "$x"
MAJOR_VERSION=`echo "$VERSION" | sed -n 's/^\([0-9]*\)\..*/\1/p'`
MYLIB="liblzo.so.$VERSION"
MYLIB_MAJOR="liblzo.so.$MAJOR_VERSION"

echo rm -f liblzo.so $MYLIB_MAJOR $MYLIB
     rm -f liblzo.so $MYLIB_MAJOR $MYLIB

CC="${CC-gcc}"
x=`grep -h "^-" b/autoconf.opt b/gcc.opt b/linux/gcc_i386.opt b/gcc_lzo.opt`
CFLAGS="$x -fPIC"
x=`grep -h "^-" b/autoconf.opt`
ASFLAGS="$x -x assembler-with-cpp -Wall"

echo Compiling $MYLIB, please be patient...
echo $CC $CFLAGS -c src/*.c
     $CC $CFLAGS -c src/*.c
echo $CC $ASFLAGS -c src/i386/src/*.s
     $CC $ASFLAGS -c src/i386/src/*.s
$CC -shared -Wl,-soname -Wl,$MYLIB_MAJOR -o $MYLIB `cat b/linux/i386.rsp`
strip --strip-unneeded $MYLIB
ln -s $MYLIB $MYLIB_MAJOR
ln -s $MYLIB_MAJOR liblzo.so

echo Building the test programs...
x=`grep -h "^-" b/autoconf.opt b/gcc.opt b/linux/gcc_i386.opt`
CFLAGS="$x -DNO_ZLIB_H -s"
$CC $CFLAGS       -o lzo_test_shared lzo_test.c          $MYLIB
$CC $CFLAGS       -o dict_shared     examples/dict.c     $MYLIB
$CC $CFLAGS       -o lpack_shared    examples/lpack.c    $MYLIB
$CC $CFLAGS       -o overlap_shared  examples/overlap.c  $MYLIB
$CC $CFLAGS       -o precomp_shared  examples/precomp.c  $MYLIB
$CC $CFLAGS       -o precomp2_shared examples/precomp2.c $MYLIB
$CC $CFLAGS       -o simple_shared   examples/simple.c   $MYLIB
$CC $CFLAGS -Isrc -o align_shared    tests/align.c       $MYLIB
$CC $CFLAGS       -o chksum_shared   tests/chksum.c      $MYLIB

echo Done.
